\input Head

\section{\tt Wavelet}

% A short (preferably one-line) description of {\tt MyClass}.

\label{class_wavelet}

{\tt Wavelet} - wavelet base class, defines generic 
wavelet metadata and methods.

\subsection{User Interface}

% % The class definition from the header file

\begin{verbatim}

class Wavelet : public udt                      // Wavelet base class
{
   public:

// constructors

      //: constructor
      Wavelet(int mH=1, int mL=1, int tree=0, enum BORDER border=B_CYCLE);

      //: copy constructor
      Wavelet(const Wavelet &);

      //: Virtual destructor
      virtual ~Wavelet();

      //: duplicate on heap
      //!return: Wavelet* - duplicate of *this, allocated on heap
      virtual Wavelet* Clone() const;

      //: Convert *this to an ILWD
      //!param: Chain - CallChain *this is part of
      //!param: Target - intended destination of ILWD
      //!return: ILwd::LdasElement* - ILWD allocated on heap or null pointer
      virtual ILwd::LdasElement*
      ConvertToIlwd( const CallChain& Chain,
                     datacondAPI::udt::target_t 
                     Target = datacondAPI::udt::TARGET_GENERIC) const;

// access functions

      //: get array index of the first sample for (level,layer)
      virtual int getOffset(int,int);             
      //: get frequency index for (level,layer)
      virtual int convertL2F(int,int);
      //: get layer index for (level,frequency index)
      virtual int convertF2L(int,int);

// mutators

      //: set level
      inline virtual void reset() { m_Level = 0; }
      inline virtual void setLevel(int level) { m_Level = level; };
      inline virtual  int getMaxLevel(int);

      //: check type of wavelet tree
      inline bool BinaryTree(){ return (m_TreeType) ? true : false; }

// data members

      //: wavelet type
      enum WAVETYPE m_WaveType;

      //: borders handling: see BORDER constants definitions above
      enum BORDER m_Border;

      //: wavelet tree type: 0-diadic, 1-binary tree
      int m_TreeType;

      //: current level of decomposition
      int m_Level;              

      //: number of highpass wavelet filter coefficients
      int m_H;

      //: number of lowpass wavelet filter coefficients
      int m_L;

}; // class Wavelet

\end{verbatim}

\subsection{Description}

% A longer description of what {\tt MyClass} is used for.

{\tt Wavelet} defines data memebers common for all wavelet types
and implements several generic  methods.

\subsection{Operating Instructions}

\subsubsection{Example Usage}

% A verbatim block of example code showing proper usage of {\tt
% MyClass}.
\begin{verbatim}

  Sequence<double> s(0.,1024);	// create sequence 
  Wavelet* w;			// create empty pointer to Wavelet
  w = new Biorthogonal(8);	// get pointer to some wavelet object

// create WaveletUDT object initialized from sequence and wavelet
  WaveletUDT<double> wu(s,*w);

\end{verbatim}


% \subsubsection{Options/Defaults}

% A list of options or defaults for public methods or member data of
% {\tt MyClass}. 


\subsection{Exceptions}

\subsubsection{Exceptions Thrown}

% A list of exceptions thrown by {\tt MyClass}.

None.

\subsubsection{Exceptions Handled}

% A list of exceptions handled by {\tt MyClass}.

None.

\subsection{Algorithms}

% A discussion of the algorithms used by {\tt MyClass}.

None.

\subsection{Accuracy}

% A discussion of issues related to the accuracy of numerical routines
% used by {\tt MyClass}---e.g., approximations,  argument ranges, etc.

Not relevant.

\subsection{Performance}

% A discussion of issues related to the speed (e.g., $O(N\log N)$) of
% computationally demanding routines used by {\tt MyClass}.

Not relevant.

\subsection{Testing}

% A description of any test code/test classes that were used to test
% {\tt MyClass}. 

Implicitly tested as part of tWaveletFunctions test.

\subsection{Notes}

% Miscellaneous notes about {\tt MyClass} that do not appear
% elsewhere, things that remain to be done, etc.  

None.

\subsection{See Also}

% A list of derived classes, base classes, etc.\ closely related to
% {\tt MyClass}. 

This class is a base class for several derived classes implementing different
wavelet transforms such as 
{\tt Haar}~(\ref{class_haar}),
{\tt Biorthogonal}~(\ref{class_biorthogonal}),
{\tt Daubechies}~(\ref{class_daubechies}),
{\tt Symlet}~(\ref{class_symlet}).
Other related classes:
{\tt WaveDWT}~(\ref{class_wavedwt}),
{\tt WaveletUDT}~(\ref{class_waveletudt}).

\subsection{References}

% A list of references for any algorithms, etc.\ used by {\tt
% MyClass}. 

None.

\input Tail


%%% Local Variables: 
%%% mode: latex
%%% TeX-master: "datacondAPI"
%%% End: 
